<?php

namespace IMATHUZH\Qfq\Core\Database;
use IMATHUZH\Qfq\Core\Store\Store;

/**
 * pgroeb: For now this is used only by Renderers. Allows access to all connected DBs
 *         as an alternative to passing down dbArray all the time.
 *         More refactoring in the future could make more use of this manager class.
 */
class DatabaseManager
{
    //TODO Make whole class static
    public int $indexQFQ;
    public int $indexData;
    public int $indexT3;

    public ?array $dbArray = null;

    //<editor-fold desc="Singleton">
    protected static ?DatabaseManager $instance = null;


    private function __construct(array $dbArray, int $indexQFQ, int $indexT3, int $indexData)
    {
        $this->dbArray = $dbArray;
        $this->indexQFQ = $indexQFQ;
        $this->indexT3 = $indexT3;
        $this->indexData = $indexData;
    }

    /**
     * @return DatabaseManager
     * @throws \CodeException
     * @throws \DbException
     * @throws \UserFormException
     * @throws \UserReportException
     */
    public static function getInstance(): DatabaseManager
    {
        // TODO: Implement an actual getInstance that works without setInstance
        return self::$instance;
    }

    /**
     * For now: Instance is set manually...
     */
    public static function setInstance(array $dbArray, int $indexQFQ, int $indexT3, int $indexData): void{
        self::$instance = new DatabaseManager($dbArray, $indexQFQ, $indexT3, $indexData);
    }
    //</editor-fold>

    public function getQfqDb() : Database{
        return $this->dbArray[$this->indexQFQ];
    }

    public function getT3Db() : Database{
        return $this->dbArray[$this->indexT3];
    }

    public function getDataDb() : Database{
        return $this->dbArray[$this->indexData];
    }
}